import java.io.*;

public class FileLister
{
   private String suffix;

   public FileLister(String suffix)
   {
      this.suffix = suffix;
   }
   public void showMatches(File dir) throws IOException
   {
      String[] entries = dir.list();
      for (int i = 0; i < entries.length; i++) {
         File entry = new File(dir, entries[i]);
         if (entry.isFile() && entry.getName().endsWith(suffix))
            System.out.println(entry.getPath());
         else if (entry.isDirectory())
            showMatches(entry);
      }
   }
   public static void main(String[] args)
      throws IOException
   {
      File rootDir = new File(args[0]);
      String suffix = args[1];
      new FileLister(suffix).showMatches(rootDir);
   }
}
