/** Example demonstrates the effect of method operations
    on primitive and reference parameter variables.
 */

public class GCParameterPassing {
    public static void tryToChangeMe( int num, StringBuffer buf ){
        // the original value will not be changed
        num = 5;
        System.out.println("I'm 'num' in tryToChangeMe(): " + num );
               
        // the original object will be changed
        buf.append(" Goodbye World!");
        
        // the original reference 'buf' will not point to the new object
        StringBuffer sb = new StringBuffer("I'm a new String!");
        buf = sb;
        System.out.println("I'm 'buf' in tryToChangeMe(): " + buf );
    }

    public static void main(String[] args) {
        int num = 10;
        StringBuffer buf = new StringBuffer("Hello World!");
        
        tryToChangeMe( num, buf );
        System.out.println();
        System.out.println("I'm 'num' after tryToChangeMe(): " + num );
        System.out.println("I'm 'buf' after tryToChangeMe(): " + buf );        
    }
}