// Approach 1 : Extending the java.lang.Thread class
class SimpleThread extends Thread
{
	public void run()
	{
		System.out.println( "SimpleThread running ... ");
		// Include code here to get the work done by the thread.
	}
}

// Approach 2 : Implementing the java.lang.Runnable interface.
class SimpleRunnable implements Runnable
{
	public void run()
	{
		System.out.println( "SimpleRunnable running ... ");
		// Include code here to get the work done by the thread.
	}
}

public class ThreadDemo
{
	public static void main( String s[] )
	{
		// No-arg constructor
		Thread t1 = new SimpleThread();	

		// Using SimpleThread reference as a target
		Thread t2 = new Thread( new SimpleThread());

		// Using a name for the thread.
		Thread t3 = new Thread( new SimpleThread(), "My first thread");

		// Using SimpleRunnable as a target
		Runnable target = new SimpleRunnable();
		Thread t4 = new Thread( target );
		
		t1.start();
		t2.start();
		t3.start();
		t4.start();
	}
}