public class UserDaemonDemo extends Thread
{
	private String myName;

	// Constructor 
	public UserDaemonDemo( String sName )
	{
		myName = sName ;
	}
	

	public void run()
	{
		if ( isDaemon())
		{
			System.out.println( "Daemon thread " + myName + " running...");
			for ( int i = 0 ; i < Integer.MAX_VALUE ; i++ )
			{
				if ( i%50 == 0 )	
					Thread.yield();
			}
		}
		else			
		{
			System.out.println( "User thread " + myName + " running...");
			// Do some processing
			for ( int i = 0 ; i < Integer.MAX_VALUE/2 ; i++ )
			{
				if ( i%50 == 0 )	
					Thread.yield();
			}
		}
		System.out.println(myName + " finished running");
	}
	
	
	public static void main( String s[] )
	{
		Thread t1 = new UserDaemonDemo("Thread #1");
		Thread t2 = new UserDaemonDemo("Thread #2");
		
		t1.start();

		t2.setDaemon(true);
		t2.start();
		
		System.out.println("Exit from main method");
	}
}