import java.io.*;
import java.util.*;

public class SubListDemo
{
   public static void main(String[] args)
      throws IOException
   {
      // Create an array of File objects representing
      // all the subdirectories in the current directory

      File[] dirs = new File(".").listFiles(new FileFilter() {
         public boolean accept(File file) {
            return file.isDirectory();
         }
      });

      // Convert the array to a list

      List dirList = new ArrayList();
      for (int i = 0; i < dirs.length; i++)
         dirList.add(dirs[i]);

      printList(dirList, "Main directories list");

      // Find the images subdirectory in the list

      File imagesDir = new File(".\\images");
      int p = dirList.indexOf(imagesDir);
      int q = p+1;

      // Find the next subdirectory after that

      File dirAfterImages = (File) dirList.get(q);

      // Create an array of entries in the images subdirectory
      // and insert these entries into the main list

      File[] entries = imagesDir.listFiles();
      for (int i = 0; i < entries.length; i++) {
         File entry = entries[i];

         // Adding an entry at the point where the next
         // directory begins moves that directory and
         // everything after it down by one.

         q = dirList.indexOf(dirAfterImages);
         dirList.add(q, entry);
      }

      printList(dirList, "After adding image entries");

      // Create sublist of just the image directory and
      // its entries

      p = dirList.indexOf(imagesDir);
      q = dirList.indexOf(dirAfterImages);
      List imageList = dirList.subList(p, q);

      printList(imageList, "Image directory sublist");

      // Remove the image directory and all its entries
      // from the main list

      imageList.clear();
      printList(dirList, "Main directories list");
   }

   public static void printList(List list, String label)
   {
      System.out.println(label + ":");
      int i = 0;
      for (Iterator it = list.iterator(); it.hasNext(); ) {
         System.out.println("   list[" + i + "] = " + it.next());
         i++;
      }
   }
}
